Tp::Client::ChannelInterfaceRoomConfigInterface Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::ChannelInterfaceRoomConfigInterface Class Reference
Channel proxies

`#include <TelepathyQt/Channel>`

Inherits Tp::AbstractInterface.

## Public Slots
QDBusPendingReply | UpdateConfiguration (const QVariantMap &properties, int timeout=-1)

## Public Member Functions
| ChannelInterfaceRoomConfigInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelInterfaceRoomConfigInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelInterfaceRoomConfigInterface (Tp::DBusProxy *proxy)
| ChannelInterfaceRoomConfigInterface (const Tp::Client::ChannelInterface &mainInterface)
| ChannelInterfaceRoomConfigInterface (const Tp::Client::ChannelInterface &mainInterface, QObject *parent)
Tp::PendingVariant * | requestPropertyAnonymous () const
Tp::PendingVariant * | requestPropertyInviteOnly () const
Tp::PendingVariant * | requestPropertyLimit () const
Tp::PendingVariant * | requestPropertyModerated () const
Tp::PendingVariant * | requestPropertyTitle () const
Tp::PendingVariant * | requestPropertyDescription () const
Tp::PendingVariant * | requestPropertyPersistent () const
Tp::PendingVariant * | requestPropertyPrivate () const
Tp::PendingVariant * | requestPropertyPasswordProtected () const
Tp::PendingVariant * | requestPropertyPassword () const
Tp::PendingVariant * | requestPropertyPasswordHint () const
Tp::PendingVariant * | requestPropertyCanUpdateConfiguration () const
Tp::PendingVariant * | requestPropertyMutableProperties () const
Tp::PendingVariant * | requestPropertyConfigurationRetrieved () const
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const

## Static Public Member Functions
static QLatin1String | staticInterfaceName ()

## Protected Member Functions
virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const

## Additional Inherited Members
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)
Protected Slots inherited from Tp::AbstractInterface

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Channel.Interface.RoomConfig1".

## Constructor & Destructor Documentation

Tp::Client::ChannelInterfaceRoomConfigInterface::ChannelInterfaceRoomConfigInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelInterfaceRoomConfigInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelInterfaceRoomConfigInterface::ChannelInterfaceRoomConfigInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelInterfaceRoomConfigInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelInterfaceRoomConfigInterface::ChannelInterfaceRoomConfigInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ChannelInterfaceRoomConfigInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

Tp::Client::ChannelInterfaceRoomConfigInterface::ChannelInterfaceRoomConfigInterface | ( | const Tp::Client::ChannelInterface & | mainInterface | ) |
| explicit

Creates a ChannelInterfaceRoomConfigInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters

  mainInterface | The proxy to use.

Tp::Client::ChannelInterfaceRoomConfigInterface::ChannelInterfaceRoomConfigInterface | ( | const Tp::Client::ChannelInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ChannelInterfaceRoomConfigInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

static QLatin1String Tp::Client::ChannelInterfaceRoomConfigInterface::staticInterfaceName | ( |  | ) |
| inlinestatic

Returns the name of the interface "org.freedesktop.Telepathy.Channel.Interface.RoomConfig1", which this class represents.

Returns
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyAnonymous | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Anonymous` of type `bool`.

True if people may join the channel without other members being made aware of their identity.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyInviteOnly | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `InviteOnly` of type `bool`.

True if people may not join the channel until they have been invited.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyLimit | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Limit` of type `uint`.

The limit to the number of members; or 0 if there is no limit.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyModerated | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Moderated` of type `bool`.

True if channel membership is not sufficient to allow participation.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyTitle | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Title` of type `QString`.

A human-visible name for the channel, if it differs from ChannelInterfaceRoomInterface::RoomName ; the empty string, otherwise.

On XMPP, this represents the `muc#roomconfig_roomname` field of the `muc#roomconfig` form. So for `jdev@conference.jabber.org`, for example:

- ChannelInterfaceRoomInterface::RoomName = `"jdev"`;
- ChannelInterfaceRoomInterface::Server = `"conference.jabber.org"`;
- Title = `"General Jabber development discussion"`.

XEP-0045 is awful.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyDescription | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Description` of type `QString`.

A human-readable description of the channel's overall purpose; if any.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyPersistent | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Persistent` of type `bool`.

`True` if the channel will remain in existence on the server after all members have left it.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyPrivate | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Private` of type `bool`.

`True` if the channel is not visible to non-members.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyPasswordProtected | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `PasswordProtected` of type `bool`.

`True` if contacts joining this channel must provide a password to be granted entry. Note that this property does not indicate that a password is required right now; see the ChannelInterfacePasswordInterface interface for the API used to provide a password while joining a room.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyPassword | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Password` of type `QString`.

If PasswordProtected is `True`, the password required to enter the channel, if known. If the password is unknown, or PasswordProtected is `False`, the empty string.
On XMPP—bless its cotton socks!—non-owners of a MUC cannot see its current password, even if they just provided the password in order to join the room…

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyPasswordHint | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `PasswordHint` of type `QString`.

If PasswordProtected is `True`, an optional hint for the password.

On protocols supporting PasswordHint (indicated by its presence in MutableProperties ), Password and PasswordHint MUST be set in a single call to UpdateConfiguration() .

Skype requires that the password and its hint be supplied together.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyCanUpdateConfiguration | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `CanUpdateConfiguration` of type `bool`.

If `True`, the user may call UpdateConfiguration() to change the values of the properties listed in MutableProperties .

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyMutableProperties | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `MutableProperties` of type `QStringList`.

A list of (unqualified) property names on this interface which may be modified using UpdateConfiguration() (if CanUpdateConfiguration is `True`). Properties not listed here cannot be modified.

For example, IRC does not have the concept of joining a room without other participants knowing your true identity; so on IRC the Anonymous property will always be `False`, and MutableProperties will not include `"Anonymous"`.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelInterfaceRoomConfigInterface::requestPropertyConfigurationRetrieved | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `ConfigurationRetrieved` of type `bool`.

`True` once the initial room configuration has been retrieved, or `False` otherwise. On some services, this may take some time after you've joined a room to fetch the configuration. Once this property changes to `True`, the other properties on this interface can be assumed to be accurate; this property MUST not change to `False` after it becomes `True`.

An application's “configure this room” dialog might choose to display a spinner while this property is `False`, rather than allowing the user to edit probably-inaccurate configuration.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::ChannelInterfaceRoomConfigInterface::requestAllProperties | ( |  | ) | const
| inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply Tp::Client::ChannelInterfaceRoomConfigInterface::UpdateConfiguration | ( | const QVariantMap & | properties,
|  | int | timeout = `-1`
| ) |  |
| inlineslot

Begins a call to the D-Bus method `UpdateConfiguration` on the remote object.

If CanUpdateConfiguration is `True`, modifies the current values of one or more room properties. This method SHOULD NOT return until the change has been accepted or declined by the server.

Note that the server may ostensibly accept the changes (thus allowing this method to return success) but signal different values; for example, the server might truncate Title to some maximum length. Callers SHOULD continue to listen for the `PropertiesChanged` signal, and trust the values it signals over those provided to this method.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  > properties | The new values of one or more properties on this interface, which must be listed in MutableProperties . For instance, to set up a channel for discussing top-secret corporate merge plans, this parameter might be:
  >     {
  >           'Private': True,
  >           'InviteOnly': True,
  >           'Description': "The first rule of #inteltakeover is: do not talk about #inteltakeover",
  >         }
  timeout | The timeout in milliseconds.

void Tp::Client::ChannelInterfaceRoomConfigInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |
| protectedvirtual

Reimplemented from Tp::AbstractInterface.